<?php
/*
Plugin Name: PHP Gallery Version 1.0
Plugin Author: Sue Feng
Description: Generates a gallery, configurations via plugin editor. You can get to that by clicking on the title of this plugin. Use  &lt;!&ndash;&ndash; gallery &ndash;&ndash;&gt; on any page in code view to display the gallery.
Plugin Author URI: http://suefeng.net
Plugin URI: /wp-admin/plugin-editor.php?file=wp-gallery-plugin.php
*/

function gallery(){
// portfolio folders
// edit these
$portfolio_title = "Portfolio"; // name of your portfolio or gallery
$portfolio_page = "/gallery.php"; // link to the file your gallery script goes in
$portfolio_folder = "../gallery/"; // folder your gallery resides in
$banner_folder = "../gallery/banners"; // folder your main menu images reside in
$thumb_folder = "../gallery/thumbs"; // folder your thumbnails reside in
$images_folder = "../gallery/images"; // folder your images reside in

// you may stop editing here

	$banner_folder = $banner_folder."/";
	$dir_handle = @opendir($banner_folder) or die('Unable to open ' . $banner_folder); 
	$array = array(); 
	while (($file = readdir($dir_handle)) !== false) { 
		if ($file != '.' && $file != '..') { 
			$banner_folderinfo = pathinfo($file); 
			if (isset($banner_folderinfo['extension'])) {$ext = strtolower($banner_folderinfo['extension']);} else {$ext = '';} 
			if ($ext == 'jpg' || $ext == 'jpeg' || $ext == 'gif' || $ext == 'png') {$array[] = $file;} 
		} 
	}  
	if (!$array) {
		echo 'No projects are available for viewing at this time.';
	}
# populate images
	if (isset($_REQUEST['cat'])){
		$folder = $_GET['cat'];
		$folder = strtolower($folder);
		$path = $thumb_folder.'/'.$folder.'/'; 
		$dir_handle = @opendir($path);
		if ($dir_handle != null) {//or die('<h3>Error</h3>Unable to open ' . $path); 
			$array = array(); 
			while (($file = readdir($dir_handle)) !== false) { 
				if ($file != '.' && $file != '..') { 
					$pathinfo = pathinfo($file); 
					if (isset($pathinfo['extension'])) {$ext = strtolower($pathinfo['extension']);} else {$ext = '';} 
					if ($ext == 'jpg' || $ext == 'jpeg' || $ext == 'gif' || $ext == 'png') {$array[] = $file;} 
				} 
			} 
			$catname = str_replace('_', ' ', $folder);
			if ($array) { 
				sort($array); 
				echo '<h3><a href="'.$portfolio_page.'">'.$portfolio_title.'</a> &raquo; '.$catname.'</h3>';
				foreach ($array as $value) { 
				$imgname = str_replace('_', ' ',$value);
				$imgname = substr($imgname, 0, -4);
				$imgname = ucwords($imgname);
					echo '
	<div class="left">
	<div class="thumb">
		<a href="/'.$images_folder.'/'.$folder.'/'.$value.'" title="'.$imgname.'">
			<img src="/'.$path.$value.'" alt="'.$imgname.'" />
		</a>
	</div>
	</div>
					'; 
				} // end foreach
			} // end if ($array)
			else {
				echo '<h3><a href="'.$portfolio_page.'">'.$portfolio_title.'</a> &raquo; '.$catname.'</h3>
				coming soon...';
			}
		} // end if directory not null
		else {
			header("Location: $error_url");
		}
echo '<div style="clear:both; margin-top: 20px;"><center><a href="'.$portfolio_page.'">&laquo; back</a></center></div>';			
	}
# populate menu
	if(empty($_REQUEST['cat']))
	{ 
		sort($array);
		echo '
		<h3>'.$portfolio_title.'</h3>
		<div id="work">';
		foreach ($array as $value) { 
		$cat = substr($value, 0, -4);	
		$cat = substr ( $cat, 3 ,strlen($cat) );
		$cat = strtolower($cat);
		$catname = str_replace('_', ' ', $cat);
			echo '
		<div class="work" style="background-image: url(/'.$banner_folder.$value.');">
			<a href="?cat='.$cat.'">
				<span><span class="work-title">'.$catname.'</span></span>
			</a>
		</div>
			'; 
		} 
		echo '</div>';
	} 
}
function generate_gallery($content) {
    if (strpos($content, "<!-- gallery -->") !== FALSE) {
        $content = preg_replace('/<p>\s*<!--(.*)-->\s*<\/p>/i', "<!--$1-->", $content);
        $content = str_replace('<!-- gallery -->', gallery(), $content);
    }
    return $content;
}
 
add_filter('the_content', 'generate_gallery');
?>